%TV phase retrieval for image reconstruction
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%^^^^^^^^^Model: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%    TV(u)+lambda/2 \| |FAu|-b \|^2
% 
clear all; close all;
getd = @(p)path(p,path);
getd('images/');
getd('source/');

order=5;
verbose=0;
%% Setup rand generator

snr=inf;P=5;s=.5;t=.5;

%% image orders
name='cameraman'; I=imread([name,'.bmp']);
pctg=.1; lambda=1e2; r1=7e-2; r2=2e-2;itmax=500; r3=8e-2;%for snr =inf, pctg=.1
%pctg=.3; lambda=1e3; r1=1e-1; r3=1e-1; r2=2e-2;itmax=500; %for snr =inf, pctg=.1
I=double(I(:,:,1)); [m,n]=size(I);m=min(m,n);I=double(I(1:fix(m/2)*2,1:fix(m/2)*2,1));

% generate variable density random sampling
DN = size(I); 	% data Size
pdf = genPDF(DN,P,pctg , 2 ,0.1,0);	% generates the sampling PDF
Omega = genSampling(pdf,10,60);		% generates a sampling pattern
disp('Gen new mask!')
sparseLevel=sum(Omega(:))/numel(Omega)
%%
%overlapping shift
[m,n]=size(I);
x=exp(1i*2*pi*s*[0:n-1]/n);
y=exp(1i*2*pi*t*[0:m-1]/m);
[x,y]=meshgrid(x,y);
D=x.*y;


FT = p2DFT(ones(size(I)), size(I), 1, 2);     % from sparseMRI_v0.2
b0 = abs(FT * I);
b1 = abs(FT * (I+   D.*I));
b2 = abs(FT * (I-1i*D.*I));




IPhase0=log(abs(b0) + eps);
IPhase1=log(abs(b1) + eps);
IPhase2=log(abs(b2) + eps);

M=length(find(Omega>0));

%
init=randn(M,3);%
init1=rand(M,3);%



%% TV phase

%%adding noise
%snr=10;
%snr = 30;

sigma2 = norm(b0)^2 / M * 10^(-snr/10);
noise = sqrt(sigma2) * init(:,1);
b0(Omega)=b0(Omega)+noise;
b0(b0<0) = 0;
sigma2 = norm(b1)^2 / M * 10^(-snr/10);
noise = sqrt(sigma2) * init(:,2);
b1(Omega)=b1(Omega)+noise;
b1(b1<0) = 0;
sigma2 = norm(b2)^2 / M * 10^(-snr/10);
noise = sqrt(sigma2) * init(:,3);
b2(Omega)=b2(Omega)+noise;
b2(b2<0) = 0;
%%%%%%%%%%%%%%%
r1PR=1e-3;r3PR=1e-2;
tic
uPR=   phaseRetrievalOverAccer     (ifftshift(b0.*Omega),ifftshift(b1.*Omega),ifftshift(b2.*Omega),s,t,r1PR,r3PR,itmax,I,ifftshift(Omega),init1,verbose);
toc

tic
outTV =phaseRetrievalTVOverAccer (ifftshift(b0.*Omega),ifftshift(b1.*Omega),ifftshift(b2.*Omega),s,t,lambda,r1,r2,itmax,I,ifftshift(Omega),init1,verbose,r3);
toc;
uTV=outTV.u;
%%

%% show the results
[snr1,snr2]=saveMainOverData(FT,I,uTV,uPR,IPhase0,Omega,snr,sparseLevel,outTV);
profile viewer
