function u=phaseRetrievalOverAccer(b0,b1,b2,s,t,r1,r3,itmax,I,Omega,init,verbose)
%Lasso oversampling without TV
% Huibin Chang 2014.1
lambda=1;

if nargin<11
   Omega=ones(size(b0));
end
% b0=b0.*Omega;
% b1=b1.*Omega;
% b2=b2.*Omega;
% 


%%
%r1=1e-1; r2=r1*1e-1;itmax=300;
[m,n]=size(b0);
p=zeros(m,2*n);
d0=zeros(m,n);
d1=d0;
d2=d0;
%q=p;

z0=zeros(m,n);
z1=z0;
z2=z0;



z0(Omega)=b0(Omega).*exp(1i*2*pi*init(:,1));
z1(Omega)=b1(Omega).*exp(1i*2*pi*init(:,2));
z2(Omega)=b2(Omega).*exp(1i*2*pi*init(:,3));

%% prepare A of Laplacian A+ I



%% prepare DFT
[m,n]=size(I);
x=exp(1i*2*pi*s*[0:m-1]/m);
y=exp(1i*2*pi*t*[0:n-1]/n);
[x,y]=meshgrid(x,y);
D=x.*y;


A=2*r1/r3*(2.5+real(D)+imag(D))+1;




w=zeros(size(I));
% v=w;
v=real(Myifftn(z0));

%%
%
%start iteration

   for counter=1:itmax
       

    
       
       
       z0hat=Myifftn(z0+d0/r1);
       z1hat=Myifftn(z1+d1/r1);
       z2hat=Myifftn(z2+d2/r1);
       vhat=v-w/r3;
       % for u sub

       g=r1/r3*(real(z0hat+z1hat+z2hat)+real(D.*conj(z1hat))+imag(D.*conj(z2hat)))+vhat;
       u=g./A;
    
       
    
       %u=min(max(0,real(u)),255);
       v=min(max(0,real(u)+w/r3),255);
       if verbose
       figure(1);imshow(u,[]);colorbar;title(num2str(counter));pause(.001)
       end
       
       
       
       
       % for v-sub
       
       z0=subZSolver(b0,Myfftn(u)-d0/r1,lambda,r1,Omega,z0);
       z1=subZSolver(b1,Myfftn(u+   D.*u)-d1/r1,lambda,r1,Omega,z1);
       z2=subZSolver(b2,Myfftn(u-1i*D.*u)-d2/r1,lambda,r1,Omega,z2);
           
 


       d0=d0+r1*(z0-Myfftn(u));
       d1=d1+r1*(z1-Myfftn(u+   D.*u));
       d2=d2+r1*(z2-Myfftn(u-1i*D.*u));
       w =w +r3*(u-v);
          

   end

   
%save all;

end







function u=Myfftn(u0)
u=fftn(u0)/sqrt(numel(u0));
end

function u=Myifftn(u0)
u=ifftn(u0)*sqrt(numel(u0));
end

function z=subZSolver(b,z0,lambda,r,Omega,zold)
        
       z=(lambda*b+r*abs(z0))./(lambda+r).*sign(z0);
       
       z=(abs(z0)==0).*(lambda*b+r*abs(z0))./(lambda+r)+(abs(z0)>0).*z;
       
       z=z0.*(1-Omega)+z.*Omega;
end
