function res = transform(FT, x, y, M, N)

% correct the global phase ambiguity
% Written by Z. Yang

x = double(x);
correlation1 = FT' * ((FT*x) .* conj(FT*y));
[m, idx] = max(abs(correlation1(:)));
[i0, j0] = ind2sub([M,N], idx);

i = i0 - M / 2 - 1;
j = j0 - N / 2 - 1;
if i < 0
    i = i + M;
end
if j < 0
    j = j + N;
end



yT1 = y([M-i+1:M 1:M-i], [N-j+1:N 1:N-j]);
c1 = sign(yT1(:)' * x(:));
y1 = c1 * yT1;

y = conj(fliplr(flipud(y)));
correlation2 = FT' * ((FT*x) .* conj(FT*y));
[m, idx] = max(abs(correlation2(:)));
[i0, j0] = ind2sub([M,N], idx);

i = i0 - M / 2 - 1;
j = j0 - N / 2 - 1;
if i < 0
    i = i + M;
end
if j < 0
    j = j + N;
end
yT2 = y([M-i+1:M 1:M-i], [N-j+1:N 1:N-j]);
c2 = sign(yT2(:)' * x(:));
y2 = c2 * yT2;

if norm(x - y1,'fro') < norm(x - y2,'fro')
    res = y1;
else
    res = y2;
end